This is the CodeSketch program, version 1.503, created on 14 Dec 2002.

---------------------------------------------------------------------------
This is the CodeSketch program, version 1.503, created on 14 Dec 2002.
There are four modes of usage: C++ class generator, ANSI C generator,
and device driver generator, and diagnostics.

Usage 1: C++ class generator (with optional makefile and unit test)
         CodeSketch -class "class1 class2 ... classN"
          [ -namespace name | -ns name ]
          [ -interface | -i ] (creates a pure virtual (interface) class
          [ -no_dump_diagnostics | -no_dd ]
          [ -no_icc ] (suppresses generation of the .icc file)
          [ -base_filename filename | -file filename ]
          ...other options (see common options, below)

Usage 2: ANSI C generator: 
         CodeSketch -ansi_c -class someName
          ...other options (see common options, below)

Usage 3: Device Driver generator (with optional makefile or bash build script)
         CodeSketch -class driverName
             -os operatingSystem        (may be lynx or linux) 
             -char_driver  | -char 
             [ -block_driver | -block ] (not yet supported)
             [ -sparse ]                (suppress generation of shared files)
          ...other options (see common options, below)

Usage 4: Diagnostics (no files are generated)
         CodeSketch -class "class1 class2 ... classN"
                  [ -diagnostics_only | -diag ]
          ...other options (see common options, below)
    or:
         CodeSketch -version | -v    (Reports version and exits)
         CodeSketch -help    | -h    (Prints this screen and exits)

Common optional parameters: (most common are listed first)
          [ -author your_name ]
          [ -initials your_initials     | -in your_initials ]
          [ -copyright copyright_string | -c copyright_string ]
          [ -output_dir a_directory     | -o a_directory ]
          [ -open_source                | -open ]
          [ -overwrite                  | -ow ]
          [ -quiet                      | -q ]
          [ -no_sccs_keywords           | -no_sccs ]
          [ -no_unit_test               | -no_ut ]
          [ -no_makefile                | -no_mf ]

For comprehensive examples, please see BasicTest.sh, included with CodeSketch.

maintained here: http://www.hubbard-software.com
---------------------------------------------------------------------------

---------------------------------------------------------------------------
This is the CodeSketch program, version 1.503, created on 14 Dec 2002.
There are four modes of usage: C++ class generator, ANSI C generator,
and device driver generator, and diagnostics.

Usage 1: C++ class generator (with optional makefile and unit test)
         CodeSketch -class "class1 class2 ... classN"
          [ -namespace name | -ns name ]
          [ -interface | -i ] (creates a pure virtual (interface) class
          [ -no_dump_diagnostics | -no_dd ]
          [ -no_icc ] (suppresses generation of the .icc file)
          [ -base_filename filename | -file filename ]
          ...other options (see common options, below)

Usage 2: ANSI C generator: 
         CodeSketch -ansi_c -class someName
          ...other options (see common options, below)

Usage 3: Device Driver generator (with optional makefile or bash build script)
         CodeSketch -class driverName
             -os operatingSystem        (may be lynx or linux) 
             -char_driver  | -char 
             [ -block_driver | -block ] (not yet supported)
             [ -sparse ]                (suppress generation of shared files)
          ...other options (see common options, below)

Usage 4: Diagnostics (no files are generated)
         CodeSketch -class "class1 class2 ... classN"
                  [ -diagnostics_only | -diag ]
          ...other options (see common options, below)
    or:
         CodeSketch -version | -v    (Reports version and exits)
         CodeSketch -help    | -h    (Prints this screen and exits)

Common optional parameters: (most common are listed first)
          [ -author your_name ]
          [ -initials your_initials     | -in your_initials ]
          [ -copyright copyright_string | -c copyright_string ]
          [ -output_dir a_directory     | -o a_directory ]
          [ -open_source                | -open ]
          [ -overwrite                  | -ow ]
          [ -quiet                      | -q ]
          [ -no_sccs_keywords           | -no_sccs ]
          [ -no_unit_test               | -no_ut ]
          [ -no_makefile                | -no_mf ]

For comprehensive examples, please see BasicTest.sh, included with CodeSketch.

maintained here: http://www.hubbard-software.com
---------------------------------------------------------------------------
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diag:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
ow:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         3
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
overwrite:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         3
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
q:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         0
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
quiet:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         0
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
ow:				
q:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         2
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
ns:				GoldNameSpace

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 GoldNameSpace
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          1
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
namespace:				BlueNameSpace

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 BlueNameSpace
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          1
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_ut:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           0
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_unit_test:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           0
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_mf:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        0
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_makefile:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        0
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
i:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 1
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
interface:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 1
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_dd:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    0
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_dump_diagnostics:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    0
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_cv:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_check_valid:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_icc:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         0
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_sccs:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       0
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
no_sccs_keywords:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       0
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
open:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         1
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
open_source:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         1
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
c:				Example Copyright (c) 2010
diagnostics_only:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 Example Copyright (c) 2010
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
copyright:				Example Copyright (c) 2011
diagnostics_only:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 Example Copyright (c) 2011
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
file:				ExampleBlueBaseFile

FirstClassName:            CodeSketchExample
ClassHeaderName:           ExampleBlueBaseFile.h
ClassInlineName:           ExampleBlueBaseFile.icc
ClassBodyName:             ExampleBlueBaseFile.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              ExampleBlueBaseFile_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              ExampleBlueBaseFile
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
base_filename:				ExampleRedBaseFile
diagnostics_only:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           ExampleRedBaseFile.h
ClassInlineName:           ExampleRedBaseFile.icc
ClassBodyName:             ExampleRedBaseFile.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              ExampleRedBaseFile_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              ExampleRedBaseFile
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
output_dir:				./ExampleDirectoryOne

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./ExampleDirectoryOne
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
o:				./ExampleDirectoryTwo

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./ExampleDirectoryTwo
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
initials:				JFH

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            JFH
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
diagnostics_only:				
in:				ABC

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.cpp
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            ABC
FileCreationFlags:         1
ModeIsCplusplus:           1
ModeIsAnsiC:               0
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
ansi_c:				
diagnostics_only:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.c
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           0
ModeIsAnsiC:               1
ModeIsDeviceDriver:        0
IsCharDriver:              0
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
char_driver:				
diagnostics_only:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.c
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           0
ModeIsAnsiC:               0
ModeIsDeviceDriver:        1
IsCharDriver:              1
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
char:				
diagnostics_only:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.c
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           0
ModeIsAnsiC:               0
ModeIsDeviceDriver:        1
IsCharDriver:              1
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
char:				
diagnostics_only:				
sparse:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.c
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           0
ModeIsAnsiC:               0
ModeIsDeviceDriver:        1
IsCharDriver:              1
IsBlockDriver:             0
SparseCodeGenerationDesired: 1
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
block_driver:				
diagnostics_only:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.c
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           0
ModeIsAnsiC:               0
ModeIsDeviceDriver:        1
IsCharDriver:              0
IsBlockDriver:             1
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
block:				
diagnostics_only:				

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.c
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           0
ModeIsAnsiC:               0
ModeIsDeviceDriver:        1
IsCharDriver:              0
IsBlockDriver:             1
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
char_driver:				
diagnostics_only:				
os:				lynx

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.c
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           0
ModeIsAnsiC:               0
ModeIsDeviceDriver:        1
IsCharDriver:              1
IsBlockDriver:             0
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     lynx
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
block_driver:				
diagnostics_only:				
os:				linux

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.c
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           0
ModeIsAnsiC:               0
ModeIsDeviceDriver:        1
IsCharDriver:              0
IsBlockDriver:             1
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     linux
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
----------------------Guidelines diagnostics dump----------------
Original commands (not necessarily in order: 
block_driver:				
diagnostics_only:				
os:				solaris

FirstClassName:            CodeSketchExample
ClassHeaderName:           CodeSketchExample.h
ClassInlineName:           CodeSketchExample.icc
ClassBodyName:             CodeSketchExample.c
MakefileName:              makefile
DeviceDriverScriptName:    BuildCodeSketchExample.bash
UnitTestName:              CodeSketchExample_UnitTest.cpp
Namespace:                 
Author:                    No author specified
Copyright:                 No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
BaseFilename:              CodeSketchExample
LynxOSInfoMainFileName:    CodeSketchExample_CreateInfo.c
LynxOSInfoHeaderFileName:  CodeSketchExample_info.h
LynxOSImportsFileName:     CodeSketchExample_imports.txt
OutputDirectory:           ./
CustomInitials:            XXX
FileCreationFlags:         1
ModeIsCplusplus:           0
ModeIsAnsiC:               0
ModeIsDeviceDriver:        1
IsCharDriver:              0
IsBlockDriver:             1
SparseCodeGenerationDesired: 0
TargetOperatingSystem:     solaris
BuildScriptDesired:        1
UnitTestDesired:           1
InlineFileDesired:         1
NamespaceDesired:          0
DumpDiagnosticsDesired:    1
OpenSourceDesired:         0
SccsKeywordsDesired:       1
PureInterfaceClassDesired: 0
Classes to be created:     
    CodeSketchExample
Created ./cstemp/Blue.h
Created ./cstemp/Blue.cpp
Created ./cstemp/Blue.icc
Created ./cstemp/Blue_UnitTest.cpp
Created ./cstemp/makefile
#############################################################################
#  makefile
#
#  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
#
#  $Revision: 1.0 $
#  $Author: AutoTester $
#############################################################################
PROGRAM=Blue_UnitTest
HEADERS=Blue.h
INCLUDES=

ifeq ("","$(TARGET)")
endif

CPP_OBJS=	    ${TARGET}/Blue.o   
C_OBJS=
UNIT_TEST_OBJS=      ${TARGET}/Blue_UnitTest.o

LOCAL_CXX:=g++
LOCAL_CC:=gcc
LINK:=g++

C_FLAGS:=-D${TARGET} -D_REENTRANT -c -O2 -g  \
	   -Wall -Wno-unknown-pragmas -Wno-unused -Werror 

CXX_FLAGS:=${CXX_FLAGS}
LINK_FLAGS= 

all: setup $(TARGET)/$(PROGRAM)
	@echo "Building for the $(TARGET) platform..."

setup:

html: ${HEADERS}
	doc++ -d html ${HEADERS}
	touch html

clean:
	@if [ -d html ];     then rm -r html;     fi;
	@if [ -d Debug ];    then rm -r Debug;    fi;
	@if [ -d Release ];  then rm -r Release;  fi;
	@if [ -f *.plg ];    then rm *.plg;       fi;
	@if [ -f *.opt ];    then rm *.opt;       fi;
	@if [ -f *.ncb ];    then rm *.ncb;       fi;
	@if [ -f *.dsw ];    then rm *.dsw;       fi;

$(TARGET)/$(PROGRAM): $(C_OBJS) $(CPP_OBJS) $(UNIT_TEST_OBJS)
	@echo "Linking $@ ..."
	$(LINK) $(LINK_FLAGS) $(C_OBJS) $(CPP_OBJS) $(UNIT_TEST_OBJS) -o $(TARGET)/$(PROGRAM)


$(TARGET)/%.o:%.cpp
	@echo "Building $@ ..."
	$(LOCAL_CXX) $(CXX_FLAGS) -c $< -o $@ $(INCLUDES)

$(TARGET)/%.o:%.c
	@echo "Building $@ ..."
	$(LOCAL_CC) $(C_FLAGS) -c $< -o $@ $(INCLUDES)

local_test: all
	@$(TARGET)/$(PROGRAM)

dev_test: all
	@$(TARGET)/$(PROGRAM) > $(PROGRAM).out

	@if cmp -s $(PROGRAM).sig $(PROGRAM).out; then   \
		echo "UnitTest $(PROGRAM):	SUCCESS";      \
	elif [ -f $(PROGRAM).sig ]; then              \
		echo "UnitTest $(PROGRAM):	FAILED";           \
		diff $(PROGRAM).sig $(PROGRAM).out;                \
	else                              \
		echo "UnitTest $(PROGRAM):	UNKNOWN (no signature file exists)";  \
	fi

/*****************************************************************************
 *  Blue.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: AutoTester $
 *************************************************************************** */
#include <string>
#include <iostream>
#include "Blue.h"

//////////////////////////////////////////////////////////////////////////////
// class Blue
Blue::Blue()
{
}
Blue::~Blue()
{
}
void Blue::DumpDiagnostics() const
{
    std::cout << "Blue diagnostics dump." << std::endl;
}
/*****************************************************************************
 *  Blue.icc
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: AutoTester $
 *************************************************************************** */
/*****************************************************************************
 *  Blue.h
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: AutoTester $
 *************************************************************************** */
#ifndef XXX__BLUE_H
#define XXX__BLUE_H

    /** TODO: Describe the Blue class in this doc++ comment block.
     *  
     */
    class Blue
    {
    public:
        Blue();
        virtual ~Blue();

        /// DumpDiagnostics sends the object's state to stdout.
        void DumpDiagnostics() const;

    private:
        // Copying or assignment of this class is prohibited, at this point:
        Blue(const Blue&);
        Blue& operator=(const Blue&);
    };

#include "Blue.icc"

#endif // XXX__BLUE_H
/*****************************************************************************
 *  Blue_UnitTest.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: AutoTester $
 *************************************************************************** */
#include <iostream>
#include "Blue.h"

int main(int argc, char * argv[])
{
    Blue instanceOfBlue;
    instanceOfBlue.DumpDiagnostics();

    return 0;
}

Created cstemp/Red.h
Created cstemp/Red.cpp
Created cstemp/Red.icc
Created cstemp/Red_UnitTest.cpp
Created cstemp/makefile
By your request, overwrote cstemp/Red.h with a new file.
By your request, overwrote cstemp/Red.cpp with a new file.
By your request, overwrote cstemp/Red_UnitTest.cpp with a new file.
By your request, overwrote cstemp/makefile with a new file.
/*****************************************************************************
 *  Red.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#include <string>
#include <iostream>
#include "Red.h"

//////////////////////////////////////////////////////////////////////////////
// class Red
Red::Red()
{
}
Red::~Red()
{
}
void Red::DumpDiagnostics() const
{
    std::cout << "Red diagnostics dump." << std::endl;
}
/*****************************************************************************
 *  Red.h
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#ifndef XXX__RED_H
#define XXX__RED_H

    /** TODO: Describe the Red class in this doc++ comment block.
     *  
     */
    class Red
    {
    public:
        Red();
        virtual ~Red();

        /// DumpDiagnostics sends the object's state to stdout.
        void DumpDiagnostics() const;

    private:
        // Copying or assignment of this class is prohibited, at this point:
        Red(const Red&);
        Red& operator=(const Red&);
    };

#endif // XXX__RED_H
/*****************************************************************************
 *  Red_UnitTest.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#include <iostream>
#include "Red.h"

int main(int argc, char * argv[])
{
    Red instanceOfRed;
    instanceOfRed.DumpDiagnostics();

    return 0;
}

Created cstemp/Yellow.h
Created cstemp/Yellow.cpp
Created cstemp/Yellow.icc
Created cstemp/Yellow_UnitTest.cpp
Created cstemp/makefile
/*****************************************************************************
 *  Yellow.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#include <string>
#include <iostream>
#include "Yellow.h"

//////////////////////////////////////////////////////////////////////////////
// class Yellow
Yellow::Yellow()
{
}
Yellow::~Yellow()
{
}
/*****************************************************************************
 *  Yellow.icc
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
/*****************************************************************************
 *  Yellow.h
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#ifndef XXX__YELLOW_H
#define XXX__YELLOW_H

    /** TODO: Describe the Yellow class in this doc++ comment block.
     *  
     */
    class Yellow
    {
    public:
        Yellow();
        virtual ~Yellow();


    private:
        // Copying or assignment of this class is prohibited, at this point:
        Yellow(const Yellow&);
        Yellow& operator=(const Yellow&);
    };

#include "Yellow.icc"

#endif // XXX__YELLOW_H
/*****************************************************************************
 *  Yellow_UnitTest.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#include <iostream>
#include "Yellow.h"

int main(int argc, char * argv[])
{
    Yellow instanceOfYellow;
    return 0;
}

Created cstemp/Orange.h
Created cstemp/Orange.cpp
Created cstemp/Orange.icc
Created cstemp/Orange_UnitTest.cpp
Created cstemp/makefile
/*****************************************************************************
 *  Orange.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe F. Smith $
 *************************************************************************** */
#include <string>
#include <iostream>
#include "Orange.h"

namespace color_test
{
//////////////////////////////////////////////////////////////////////////////
// class Orange
Orange::Orange()
{
}
Orange::~Orange()
{
}
void Orange::DumpDiagnostics() const
{
    std::cout << "Orange diagnostics dump." << std::endl;
}

} // end of namespace color_test
/*****************************************************************************
 *  Orange.icc
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe F. Smith $
 *************************************************************************** */
namespace color_test
{
} // end of namespace color_test
/*****************************************************************************
 *  Orange.h
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe F. Smith $
 *************************************************************************** */
#ifndef JFS_COLOR_TEST_ORANGE_H
#define JFS_COLOR_TEST_ORANGE_H

namespace color_test
{
    /** TODO: Describe the Orange class in this doc++ comment block.
     *  
     */
    class Orange
    {
    public:
        Orange();
        virtual ~Orange();

        /// DumpDiagnostics sends the object's state to stdout.
        void DumpDiagnostics() const;

    private:
        // Copying or assignment of this class is prohibited, at this point:
        Orange(const Orange&);
        Orange& operator=(const Orange&);
    };

} // end of namespace color_test
#include "Orange.icc"

#endif // JFS_COLOR_TEST_ORANGE_H
/*****************************************************************************
 *  Orange_UnitTest.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe F. Smith $
 *************************************************************************** */
#include <iostream>
#include "Orange.h"

int main(int argc, char * argv[])
{
    using namespace color_test;
    Orange instanceOfOrange;
    instanceOfOrange.DumpDiagnostics();

    return 0;
}

Created cstemp/Fruits.h
Created cstemp/Fruits.cpp
Created cstemp/Fruits.icc
Created cstemp/Fruits_UnitTest.cpp
Created cstemp/makefile
/*****************************************************************************
 *  Fruits.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#include <string>
#include <iostream>
#include "Fruits.h"

namespace fruit_namespace
{
//////////////////////////////////////////////////////////////////////////////
// class Apple
Apple::Apple()
{
}
Apple::~Apple()
{
}
void Apple::DumpDiagnostics() const
{
    std::cout << "Apple diagnostics dump." << std::endl;
}
//////////////////////////////////////////////////////////////////////////////
// class Pear
Pear::Pear()
{
}
Pear::~Pear()
{
}
void Pear::DumpDiagnostics() const
{
    std::cout << "Pear diagnostics dump." << std::endl;
}
//////////////////////////////////////////////////////////////////////////////
// class Blueberry
Blueberry::Blueberry()
{
}
Blueberry::~Blueberry()
{
}
void Blueberry::DumpDiagnostics() const
{
    std::cout << "Blueberry diagnostics dump." << std::endl;
}

} // end of namespace fruit_namespace
/*****************************************************************************
 *  Fruits.icc
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
namespace fruit_namespace
{
} // end of namespace fruit_namespace
/*****************************************************************************
 *  Fruits.h
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#ifndef XXX_FRUIT_NAMESPACE_FRUITS_H
#define XXX_FRUIT_NAMESPACE_FRUITS_H

namespace fruit_namespace
{
    /** TODO: Describe the Apple class in this doc++ comment block.
     *  
     */
    class Apple
    {
    public:
        Apple();
        virtual ~Apple();

        /// DumpDiagnostics sends the object's state to stdout.
        void DumpDiagnostics() const;

    private:
        // Copying or assignment of this class is prohibited, at this point:
        Apple(const Apple&);
        Apple& operator=(const Apple&);
    };

    /** TODO: Describe the Pear class in this doc++ comment block.
     *  
     */
    class Pear
    {
    public:
        Pear();
        virtual ~Pear();

        /// DumpDiagnostics sends the object's state to stdout.
        void DumpDiagnostics() const;

    private:
        // Copying or assignment of this class is prohibited, at this point:
        Pear(const Pear&);
        Pear& operator=(const Pear&);
    };

    /** TODO: Describe the Blueberry class in this doc++ comment block.
     *  
     */
    class Blueberry
    {
    public:
        Blueberry();
        virtual ~Blueberry();

        /// DumpDiagnostics sends the object's state to stdout.
        void DumpDiagnostics() const;

    private:
        // Copying or assignment of this class is prohibited, at this point:
        Blueberry(const Blueberry&);
        Blueberry& operator=(const Blueberry&);
    };

} // end of namespace fruit_namespace
#include "Fruits.icc"

#endif // XXX_FRUIT_NAMESPACE_FRUITS_H
/*****************************************************************************
 *  Fruits_UnitTest.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#include <iostream>
#include "Fruits.h"

int main(int argc, char * argv[])
{
    using namespace fruit_namespace;
    Apple instanceOfApple;
    instanceOfApple.DumpDiagnostics();

    Pear instanceOfPear;
    instanceOfPear.DumpDiagnostics();

    Blueberry instanceOfBlueberry;
    instanceOfBlueberry.DumpDiagnostics();

    return 0;
}

#############################################################################
#  makefile
#
#  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
#
#  $Revision: 1.0 $
#  $Author: Joe Smith $
#############################################################################
PROGRAM=Fruits_UnitTest
HEADERS=Fruits.h
INCLUDES=

ifeq ("","$(TARGET)")
endif

CPP_OBJS=	    ${TARGET}/Fruits.o   
C_OBJS=
UNIT_TEST_OBJS=      ${TARGET}/Fruits_UnitTest.o

LOCAL_CXX:=g++
LOCAL_CC:=gcc
LINK:=g++

C_FLAGS:=-D${TARGET} -D_REENTRANT -c -O2 -g  \
	   -Wall -Wno-unknown-pragmas -Wno-unused -Werror 

CXX_FLAGS:=${CXX_FLAGS}
LINK_FLAGS= 

all: setup $(TARGET)/$(PROGRAM)
	@echo "Building for the $(TARGET) platform..."

setup:

html: ${HEADERS}
	doc++ -d html ${HEADERS}
	touch html

clean:
	@if [ -d html ];     then rm -r html;     fi;
	@if [ -d Debug ];    then rm -r Debug;    fi;
	@if [ -d Release ];  then rm -r Release;  fi;
	@if [ -f *.plg ];    then rm *.plg;       fi;
	@if [ -f *.opt ];    then rm *.opt;       fi;
	@if [ -f *.ncb ];    then rm *.ncb;       fi;
	@if [ -f *.dsw ];    then rm *.dsw;       fi;

$(TARGET)/$(PROGRAM): $(C_OBJS) $(CPP_OBJS) $(UNIT_TEST_OBJS)
	@echo "Linking $@ ..."
	$(LINK) $(LINK_FLAGS) $(C_OBJS) $(CPP_OBJS) $(UNIT_TEST_OBJS) -o $(TARGET)/$(PROGRAM)


$(TARGET)/%.o:%.cpp
	@echo "Building $@ ..."
	$(LOCAL_CXX) $(CXX_FLAGS) -c $< -o $@ $(INCLUDES)

$(TARGET)/%.o:%.c
	@echo "Building $@ ..."
	$(LOCAL_CC) $(C_FLAGS) -c $< -o $@ $(INCLUDES)

local_test: all
	@$(TARGET)/$(PROGRAM)

dev_test: all
	@$(TARGET)/$(PROGRAM) > $(PROGRAM).out

	@if cmp -s $(PROGRAM).sig $(PROGRAM).out; then   \
		echo "UnitTest $(PROGRAM):	SUCCESS";      \
	elif [ -f $(PROGRAM).sig ]; then              \
		echo "UnitTest $(PROGRAM):	FAILED";           \
		diff $(PROGRAM).sig $(PROGRAM).out;                \
	else                              \
		echo "UnitTest $(PROGRAM):	UNKNOWN (no signature file exists)";  \
	fi

Created cstemp/Purple.c
Created cstemp/Purple.h
Created cstemp/Purple_UnitTest.cpp
Created cstemp/makefile
/*****************************************************************************
 *  Purple.c
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#include <stdio.h>
#include "Purple.h"

int ExampleHelloRoutine()
{
    printf("Hello, from Purple!\n");
    return 0;
}

/*****************************************************************************
 *  Purple.h
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#ifndef XXX__PURPLE_H
#define XXX__PURPLE_H

#ifdef __cplusplus
extern "C"
{
#endif //  __cplusplus

    int ExampleHelloRoutine();

#ifdef __cplusplus
}
#endif //  __cplusplus

#endif // XXX__PURPLE_H

/*****************************************************************************
 *  Purple_UnitTest.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#include <stdio.h>
#include "Purple.h"

int main(int argc, char * argv[])
{
    ExampleHelloRoutine();
    return 0;
}

Created cstemp/White.c
Created cstemp/BuildWhite.bash
Created cstemp/CommonBuildRoutines.bash
Created cstemp/StandardCodeSketchCommands.h
Created cstemp/makefile
/*****************************************************************************
 *  White.c
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#ifdef __KERNEL__
    #include <linux/types.h>
    #include <linux/stddef.h>
    #include <linux/kernel.h>
    #include <linux/config.h>
    #include <linux/module.h>
    #include <linux/pci.h>
    #include <linux/fs.h>
    #include <asm/uaccess.h>
    #include <asm/semaphore.h>
#else
     #error "Failed to define __KERNEL__"
#endif

#include "StandardCodeSketchCommands.h"

#ifdef MODULE
    MODULE_LICENSE("GPL and additional rights");
    MODULE_AUTHOR("Joe Smith");
    MODULE_DESCRIPTION("White: A full prototype device driver.");
#else
     #error "Failed to define MODULE"
#endif

#define MAX_FULL_DRIVER_STORAGE          512
#define MAX_DIAG_MESSAGE_LENGTH          512

loff_t             White_llseek(struct file * apFile, loff_t aOffset, int whence);
static int         White_open(struct inode *, struct file *);
static int         White_release(struct inode *, struct file *);
static ssize_t     White_read(struct file *, char *, size_t, loff_t *);
static ssize_t     White_write(struct file *, const char *, size_t, loff_t *);
static int         White_ioctl( struct inode *, struct file *, unsigned int, unsigned long );

// Linux kernel 2.4.18-10 file operations signatures, for reference:
// struct file_operations {
//     struct module *owner;
//     loff_t (*llseek) (struct file *, loff_t, int);
//     ssize_t (*read) (struct file *, char *, size_t, loff_t *);
//     ssize_t (*write) (struct file *, const char *, size_t, loff_t *);
//     int (*readdir) (struct file *, void *, filldir_t);
//     unsigned int (*poll) (struct file *, struct poll_table_struct *);
//     int (*ioctl) (struct inode *, struct file *, unsigned int, unsigned long);
//     int (*mmap) (struct file *, struct vm_area_struct *);
//     int (*open) (struct inode *, struct file *);
//     int (*flush) (struct file *);
//     int (*release) (struct inode *, struct file *);
//     int (*fsync) (struct file *, struct dentry *, int datasync);
//     int (*fasync) (int, struct file *, int);
//     int (*lock) (struct file *, int, struct file_lock *);
//     ssize_t (*readv) (struct file *, const struct iovec *, unsigned long, loff_t *);
//     ssize_t (*writev) (struct file *, const struct iovec *, unsigned long, loff_t *);
//     ssize_t (*sendpage) (struct file *, struct page *, int, size_t, loff_t *, int);
//     unsigned long (*get_unmapped_area)(struct file *, unsigned long, unsigned long, unsigned long, unsigned long);
// };

struct file_operations Fops =
{
    llseek:  White_llseek,    
    read:    White_read,    
    write:   White_write,     
    ioctl:   White_ioctl,    
    open:    White_open,    
    release: White_release
};

typedef struct WhiteData
{
    loff_t     mSize;
    loff_t     mOffset;
    char       mpBuffer[MAX_FULL_DRIVER_STORAGE];
    char       mpDiagnosticsMessage[MAX_DIAG_MESSAGE_LENGTH];

} WhiteData;


static const int          SUCCESS     = 0;
static const char * const DEVICE_NAME = "White";

static int  gMajorDeviceNumber        = 0;
static struct semaphore gSem;
static WhiteData * gpDEVICE =0;


int
init_module()
{
    const char * pMessage = "This data was written when init_module() was called.\n";
    printk(KERN_INFO "init_module: Allocating resources.\n");
    // Allocate and initialize the private data used by this device:
    gpDEVICE = (WhiteData *) kmalloc(sizeof(WhiteData), GFP_KERNEL);

    if( !gpDEVICE )
    {   return -ENOMEM;
    }

    memset(gpDEVICE, '\0', sizeof(*gpDEVICE) );
    strcpy(gpDEVICE->mpBuffer, pMessage);
    gpDEVICE->mSize = strlen(pMessage);
    strcpy(gpDEVICE->mpDiagnosticsMessage, "Original diagnostics message; overwritten later");

    sema_init(&gSem, 1);

    gMajorDeviceNumber = register_chrdev(0, DEVICE_NAME, &Fops);

    if (gMajorDeviceNumber < 0)
    {
        printk ("Failed to register %s, major number %d\n", DEVICE_NAME, gMajorDeviceNumber);
        return gMajorDeviceNumber;
    }
    
    printk ("Successully registered %s, major number %d\n", DEVICE_NAME, gMajorDeviceNumber);
    printk ("Run: mknod /dev/%s c %d 0\n", DEVICE_NAME, gMajorDeviceNumber);
    return 0;
}

void
cleanup_module()
{
    int result = 0;

    printk(KERN_INFO "cleanup_module: Freeing resources.\n");
    kfree(gpDEVICE);


    result = unregister_chrdev(gMajorDeviceNumber, DEVICE_NAME);
    if (result < 0)
    {
        printk(KERN_INFO "Failed to unregister the device driver, error code: %d\n", result);
        return;
    }
    printk ("Successully unregistered %s\n", DEVICE_NAME);
}

int
White_open(struct inode * apInode, struct file * apFile)
{
    WhiteData * pDevice = 0;
    if( !apFile )
    {
        printk(KERN_INFO "ERROR in White_open: a NULL file * was provided.\n");
        return -EINVAL;
    }

    if( ! apFile->private_data)
    {
        apFile->private_data = gpDEVICE;
    }
    
    MOD_INC_USE_COUNT;
    return 0;
}

int
White_release(struct inode * apInode, struct file * apFile)
{
    WhiteData * pDevice = 0;
    if( !apFile || !apFile->private_data )
    {
        printk(KERN_INFO "ERROR in White_release: NULL input detected.\n");
        return -EINVAL;
    }

    if( apFile->private_data)
    {
        apFile->private_data = NULL;
    }

    MOD_DEC_USE_COUNT;
    return 0;
}

loff_t
White_llseek(struct file * apFile, loff_t aOffset, int whence)
{
    // return -ESPIPE; // This is how to disable llseek correctly.

    WhiteData * pDevice = 0;
    loff_t           newPosition = 0;

    if( !apFile || !apFile->private_data )
    {
        printk(KERN_INFO "ERROR in White_llseek: NULL input detected.\n");
        return -EINVAL;
    }
    pDevice = apFile->private_data;

    switch(whence)
    {
    case 0: // SEEK_SET
        newPosition = aOffset;
        break;

    case 1: // SEEK_CUR
        newPosition = pDevice->mOffset + aOffset;
        break;

    case 2: // SEEK_END
        newPosition = pDevice->mSize + aOffset;
        break;

    default:
        return -EINVAL;
    }

    if( newPosition < 0 )
    {
        return -EINVAL;
    }
    pDevice->mOffset = newPosition;
    return newPosition;
}

static int
White_ioctl( struct inode * apInode,
                      struct file * apFile,
                      unsigned int aCommand,
                      unsigned long aArg)
{
    WhiteData * pDevice = 0;
    StandardCodeSketchCommands * pCommandData = 0;
    char exampleMessage[] = "Example diagnostics message from within White_ioctl.\n";

    if( !apFile || !apFile->private_data )
    {
        printk(KERN_INFO "ERROR in White_ioctl: NULL input detected.\n");
        return -EINVAL;
    }
    pDevice = apFile->private_data;

    if( CODE_SKETCH_OVERALL_COMMAND_TO_IOCTL == aCommand )
    {
        if( 0 == aArg )
        {
            return -EINVAL;
        }

        pCommandData = (StandardCodeSketchCommands *) aArg;

        if (down_interruptible(&gSem))
        {
            printk(KERN_INFO "Error in White_write, down_interruptible call.\n");
            return -ERESTARTSYS;
        }
        
        switch( pCommandData->mCommand )
        {
        case CODE_SKETCH_COMMAND_DUMP:

            sprintf(pDevice->mpDiagnosticsMessage, "Diagnostics report: \n"
                    "Size: %llu, Offset (seek position): %llu \n",
                    pDevice->mSize, pDevice->mOffset);
            if (copy_to_user(pCommandData->mBufferOut, pDevice->mpDiagnosticsMessage,
                             strlen(pDevice->mpDiagnosticsMessage)))
            {
                printk(KERN_INFO "Error in White_ioctl, copy_from_user routine.\n");
                up(&gSem);
                return -EFAULT;
            }
            break;
            
        case CODE_SKETCH_COMMAND_SEEK_FORWARD:

            break;
            
        case CODE_SKETCH_COMMAND_SEEK_BACK:

            break;
            
        default:
            // Do nothing
            break;
            
        }
    }
    up(&gSem);
    return 0;
}

ssize_t
White_read(struct file * apFile, char * apBuffer, size_t aLength, loff_t * aOffset)
{
    WhiteData * pDevice = 0;
    ssize_t bytesRead = 0;
    
    if( !apFile || !apFile->private_data )
    {
        printk(KERN_INFO "ERROR in White_read: NULL input detected.\n");
        return -EINVAL;
    }
    pDevice = apFile->private_data;

    // This device remembers where its seek position is, even after the
    // associated node is opened or closed repeatedly.
    if( pDevice->mOffset > *aOffset  )
    {
        *aOffset = pDevice->mOffset;
    }
    
    if( *aOffset >= pDevice->mSize )
    {
        *aOffset = 0;
        pDevice->mOffset = *aOffset;
        return 0;
    }
    
    if (down_interruptible(&gSem))
    {
        printk(KERN_INFO "Error in White_read, down_interruptible call.\n");
        return -ERESTARTSYS;
    }
    
    if (copy_to_user(apBuffer, &pDevice->mpBuffer[*aOffset], pDevice->mSize - *aOffset))
    {
        printk(KERN_INFO "Error in White_read, copy_from_user routine.\n");
        up(&gSem);
        return -EFAULT;
    }
    
    bytesRead = pDevice->mSize - *aOffset;
    *aOffset += bytesRead;
    pDevice->mOffset = *aOffset;
    
    up(&gSem);
    return bytesRead;
}

ssize_t
White_write( struct file *     apFile,
                      const char *         apBuffer,
                      size_t               aLength,
                      loff_t *             aOffset)
{
    WhiteData * pDevice = 0;


    if( !apFile || !apFile->private_data )
    {
        printk(KERN_INFO "ERROR in White_write: NULL input detected.\n");
        return -EINVAL;
    }
    pDevice = apFile->private_data;

    if( aLength >  MAX_FULL_DRIVER_STORAGE - 1)
    {
        printk(KERN_INFO "ERROR in White_write: Input is too long to accept.\n");
        return -ENOMEM;
    }
    if (down_interruptible(&gSem))
    {
        printk(KERN_INFO "Error in White_write, down_interruptible call.\n");
        return -ERESTARTSYS;
    }
    
    if (copy_from_user(pDevice->mpBuffer, apBuffer, aLength))
    {
        printk(KERN_INFO "Error in White_write, copy_from_user routine.\n");
        up(&gSem);
        return -EFAULT;
    }
    pDevice->mpBuffer[aLength] = '\0';
    pDevice->mSize = aLength;
    
    *aOffset += aLength;
    up(&gSem);
    return aLength;

}
#!/bin/bash
#############################################################################
#  BuildWhite.bash
#
#  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
#
#  $Revision: 1.0 $
#  $Author: Joe Smith $
#############################################################################

#
# File Contents: This is a bash script to build real device drivers for Linux.
# Please note that there are some commands in this script that require bash,
# not just sh.
#
# Usage:
#
#   BuildDeviceDrivers.sh  [-tidy] [-verbose]
#
#      -tidy removes the object files from the driver directory,
#      so as to make it easier to type the insmod command (for example).
#
#      -verbose shows more details as to what compile and link commands
#      are being issued.
#
# To add an additional, new driver, simply follow these easy steps:
#
#     1. Add the name of the new driver to the PROGRAMS variable.
#     2. Create a new variable, whose name is aaa_FILES, where "aaa" refers to
#        the new name that you added in step 1.
#     3. Add source files to the variable you created in step 2.
#     4. Add any common source files to the COMMON_FILES variable.
#
###############################################################################


PROGRAMS="White"

# Files for each driver, and files common to more than one driver. Please note
# that full or relative paths may be used, as long as the base file names are
# unique.

White_FILES="White.c"
COMMON_FILES=

LYNXOS_KERNEL_SYMBOLS_IMPORT_FILENAME=White_imports.txt
source CommonBuildRoutines.bash
#!/bin/bash
#############################################################################
#  CommonBuildRoutines.bash
#
#  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
#
#  $Revision: 1.0 $
#  $Author: Joe Smith $
#############################################################################

# Usage: Source this file from within your specific build script.
#
#      -tidy removes the object files from the driver directory,
#      so as to make it easier to type the insmod command (for example).
#
#      -verbose shows more details as to what compile and link commands
#      are being issued.
#
###############################################################################

echo "Performing a clean build of the following drivers: ${PROGRAMS}"

    CC=gcc
    LINK="ld -r"
    KERNELDIR="/usr/src/linux-2.4"
    INCLUDES="-I ${KERNELDIR}/include -I . "
    
    CFLAGS="-D __KERNEL__  -D MODULE -O2 -Wall -Wno-unknown-pragmas -Wno-unused"
    
    CC=gcc
    LINK="ld -bM:SRE -bimport:${LYNXOS_KERNEL_SYMBOLS_IMPORT_FILENAME}"
    INCLUDES=""
    INCLUDES="${INCLUDES} -I/usr/lynx/3.1.0/ppc/sys/include/kernel"
    INCLUDES="${INCLUDES} -I/usr/lynx/3.1.0/ppc/sys/include/family/ppc"
    INCLUDES="${INCLUDES} -I/usr/lynx/3.1.0/ppc/sys/lynx.os"
    
    CFLAGS="-D${TARGET} -O2 -Wall -Wno-unknown-pragmas -Wno-unused -D__NO_INCLUDE_WARN__ -D__LYNXOS"
else
    exit -1       
fi
    

# Search input parameters for position-independent switches:
VERBOSE="false"
TIDY="false"

for ARGS in $*
do
    if [ ${ARGS} = "-tidy" ] ;  then TIDY="true";    fi
done

function compile_files
{
    local sourceFile
    for sourceFile in $*
    do
        echo "Compiling ${sourceFile} ..."
        MakeObjectFileFromSourceFile ${sourceFile}
        
        if [ ${VERBOSE} = "true" ]; then
            echo "${CC} -c ${CFLAGS} ${INCLUDES} ${sourceFile} -o ${OBJ_FILE}"
        fi
        
        ${CC} -c ${CFLAGS} ${INCLUDES} ${sourceFile} -o ${OBJ_FILE}
    done
}

function MakeObjectFileFromSourceFile
{
    local sourceFile=$@
    # Strip off any reference to another directory (such as ../otherDir/)
    # This has the effect of requiring unique source file names, even
    # though they may reside in different directories.
    sourceFile=${sourceFile##*/}
    objFile=${sourceFile%.*}.o
    OBJ_FILE="${TARGET}/${objFile}"
}

function MakeObjectFileListFromSourceFileList
{
    # OBJ_FILE_LIST is not local; function result is placed in this variable.
    OBJ_FILE_LIST=""
    for sourceFile in $*
    do
        MakeObjectFileFromSourceFile ${sourceFile}
        OBJ_FILE_LIST="${OBJ_FILE_LIST} ${OBJ_FILE}"
    done
}

function MakeSourceFileListFromProgramName
{
    # SOURCE_FILE_LIST is not local; function result is placed in this variable.
    SOURCE_FILE_LIST=""
    local programName=$1
    local temp="${programName}_FILES"
    eval SOURCE_FILE_LIST=$(echo "\${${temp}}")
}

function link_files
{
    local programName=$1
    local outputFile=${TARGET}/${programName}.drv
    echo "Linking ${outputFile}..."
    MakeSourceFileListFromProgramName ${programName}
    
    MakeObjectFileListFromSourceFileList ${SOURCE_FILE_LIST} ${COMMON_FILES}
    
    if [ ${VERBOSE} = "true" ]; then
        echo "${LINK} ${OBJ_FILE_LIST} -o ${outputFile}"
    fi
    ${LINK} ${OBJ_FILE_LIST} -o ${outputFile}
}

# Compile files that are unique to each program:
for programName in ${PROGRAMS}
do
    MakeSourceFileListFromProgramName ${programName}
    compile_files ${SOURCE_FILE_LIST}
done

# Compile files that shared among two or more programs:
compile_files ${COMMON_FILES}

# Link each program:
for name in ${PROGRAMS}
do
    link_files ${name}
done

if [ ${TIDY} = "true" ]; then
    echo "Removing intermediate files, because you specified -tidy..."
    rm ${TARGET}/*.o
fi        
/*****************************************************************************
 *  StandardCodeSketchCommands.h
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#ifndef JFH_STANDARD_CODE_SKETCH_COMMANDS_H
#define JFH_STANDARD_CODE_SKETCH_COMMANDS_H

#define STANDARD_COMMAND_BUFFER_SIZE_CODE_SKETCH  512

#ifdef __cplusplus
extern "C" {
#endif

typedef struct StandardCodeSketchCommands
{
     long    mCommand;
     long    mDataIn;
     long    mDataOut;
     char    mBufferIn [ STANDARD_COMMAND_BUFFER_SIZE_CODE_SKETCH ];
     char    mBufferOut[ STANDARD_COMMAND_BUFFER_SIZE_CODE_SKETCH ];
} StandardCodeSketchCommands;

#define CODE_SKETCH_OVERALL_COMMAND_TO_IOCTL         1000
#define CODE_SKETCH_COMMAND_DUMP                     1001
#define CODE_SKETCH_COMMAND_SEEK_FORWARD             1002
#define CODE_SKETCH_COMMAND_SEEK_BACK                1003

#ifdef __cplusplus
 }
#endif

#endif /* JFH_STANDARD_CODE_SKETCH_COMMANDS_H */
#############################################################################
#  makefile
#
#  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
#
#  $Revision: 1.0 $
#  $Author: Joe Smith $
#############################################################################

all: tidy

debug: verbose

setup: 
	if [ ! -x BuildWhite.bash ]; then chmod u+x BuildWhite.bash; fi
	if [ ! -d ${TARGET} ]; then mkdir ${TARGET};fi

verbose: setup
	./BuildWhite.bash  -verbose

tidy: setup
	./BuildWhite.bash  -tidy

lynx_info: setup ${TARGET}/White_CreateInfo
	${TARGET}/White_CreateInfo > ${TARGET}/White_Info.bin
	
${TARGET}/White_CreateInfo: White_CreateInfo.c
	gcc $< -o $@

Created cstemp/Black.h
Created cstemp/Black.cpp
Created cstemp/Black.icc
Created cstemp/Black_UnitTest.cpp
Created cstemp/makefile
/*****************************************************************************
 *  Black.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#include <string>
#include <iostream>
#include "Black.h"

namespace color_test
{
//////////////////////////////////////////////////////////////////////////////
// class Black
Black::Black()
{
}
Black::~Black()
{
}
void Black::DumpDiagnostics() const
{
    std::cout << "Black diagnostics dump." << std::endl;
}

} // end of namespace color_test
/*****************************************************************************
 *  Black.icc
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
namespace color_test
{
} // end of namespace color_test
/*****************************************************************************
 *  Black.h
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#ifndef XXX_COLOR_TEST_BLACK_H
#define XXX_COLOR_TEST_BLACK_H

namespace color_test
{
    /** TODO: Describe the Black class in this doc++ comment block.
     *  
     */
    class Black
    {
    public:
        Black();
        virtual ~Black();

        /// DumpDiagnostics sends the object's state to stdout.
        void DumpDiagnostics() const;

    private:
        // Copying or assignment of this class is prohibited, at this point:
        Black(const Black&);
        Black& operator=(const Black&);
    };

} // end of namespace color_test
#include "Black.icc"

#endif // XXX_COLOR_TEST_BLACK_H
/*****************************************************************************
 *  Black_UnitTest.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *  $Revision: 1.0 $
 *  $Author: Joe Smith $
 *************************************************************************** */
#include <iostream>
#include "Black.h"

int main(int argc, char * argv[])
{
    using namespace color_test;
    Black instanceOfBlack;
    instanceOfBlack.DumpDiagnostics();

    return 0;
}

Created cstemp/Grey.h
Created cstemp/Grey_UnitTest.cpp
Created cstemp/makefile
/*****************************************************************************
 *  Grey.h
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *************************************************************************** */
#ifndef XXX_COLOR_TEST_GREY_H
#define XXX_COLOR_TEST_GREY_H

namespace color_test
{
    /** TODO: Describe the Grey class in this doc++ comment block.
     *  
     */
    class Grey
    {
    public:
        virtual ~Grey() {}
        virtual void ExampleInterfaceMethod() = 0;
    };

} // end of namespace color_test
#endif // XXX_COLOR_TEST_GREY_H
/*****************************************************************************
 *  Grey_UnitTest.cpp
 *
 *  No copyright declared: Auto-generated by CodeSketch (www.hubbard-software.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *************************************************************************** */
#include <iostream>
#include "Grey.h"

int main(int argc, char * argv[])
{
    using namespace color_test;
    class GreyChild : public Grey
    {
    public:
	    void ExampleInterfaceMethod()
	    {
		    std::cout << "Hello from the concrete implementation of the Grey interface!"
			    	  << std::endl;
	    }
    };

    GreyChild instanceOfGreyChild;
    instanceOfGreyChild.ExampleInterfaceMethod();
    return 0;
}

Created cstemp/Green.c
Created cstemp/Green_imports.txt
Created cstemp/Green_CreateInfo.c
Created cstemp/Green_info.h
Created cstemp/BuildGreen.bash
By your request, overwrote cstemp/CommonBuildRoutines.bash with a new file.
By your request, overwrote cstemp/StandardCodeSketchCommands.h with a new file.
Created cstemp/makefile
/*****************************************************************************
 *  Green.c
 *
 *  Copyright (C) 3001, G.Jones
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *  $Revision: 1.0 $
 *  $Author: George Jones $
 *************************************************************************** */
#include <conf.h>
#include <kern_proto.h>
#include <kernel.h>
#include <sys/file.h>
#include <file.h>
#include <dldd.h>
#include <string.h>
#include "Green_info.h"

#endif

void GreenDriverDiagnosticsDump_Statics(const GreenDriverStatics * apStatics);

int
Green_Open(GreenDriverStatics * apStatics, int aDeviceNo, struct file * f)
{
    kkprintf("Entering Green_Open. Device number: %d.\n", aDeviceNo);
    return 0;
}

int
Green_Close(GreenDriverStatics * apStatics, struct file * f)
{
    kkprintf("Entering Green_Close...\n");
    return 0;
}

int
Green_Read(GreenDriverStatics *     apStatics,
          struct file *         f,
          char *                 buff,
          register int             count)
{
    kkprintf("Entering Green_Read...\n");
    GreenDriverDiagnosticsDump_Statics( apStatics );
    return 0;
}

int
Green_Write(GreenDriverStatics *     apStatics,
           struct file *         f,
           char *                 buff,
           register int         count)
{
    kkprintf("Entering Green_Write...\n");
    GreenDriverDiagnosticsDump_Statics( apStatics );
    return count;
}

int Green_Select()
{
    return SYSERR;
}

int
Green_Ioctl(GreenDriverStatics * apStatics,
           struct file * f,
           int aCommand,
           char * apArg)
{
    kkprintf("Entering Green_Ioctl, with command number ...\n", aCommand);
    
    return 0;
}

char *
Green_Install(GreenDriverInfo * apInfo)
{
    GreenDriverStatics * pStatics = 0;
    kkprintf("Entering Green_Install...");

    if( apInfo )
    {
        pStatics = (GreenDriverStatics *)sysbrk( (long)sizeof(*pStatics) );
        if( pStatics )
        {
            memset(pStatics, 0, sizeof(*pStatics));
            pStatics->mVendorID = apInfo->mVendorID;
            pStatics->mDeviceID = apInfo->mDeviceID;
            pStatics->mYourCustomDataHere = 550; // For example...

            GreenDriverDiagnosticsDump_Statics( pStatics );
        }
    }
    else
    {
        kkprintf("Null apInfo pointer was passed in.\n");
        return (char *) SYSERR;
    }

    return (char *) pStatics;
}

int
Green_Uninstall(GreenDriverStatics * apStatics)
{
    kkprintf("Entering Green_Uninstall...\n");
    GreenDriverDiagnosticsDump_Statics( apStatics );

    sysfree((void*)apStatics, (long)sizeof(*apStatics));
    return 0;
}

#ifdef LYNXOS_X86
    static
#endif // LYNXOS_X86

    struct dldd entry_points =
    {
        Green_Open,
        Green_Close,
        Green_Read,
        Green_Write,
        Green_Select,
        Green_Ioctl,
        Green_Install,
        Green_Uninstall,
        (char *) 0
    };

void
GreenDriverDiagnosticsDump_Statics(const GreenDriverStatics * apStatics)
{
    if( apStatics )
    {
        kkprintf("GreenDriverDiagnosticsDump_Statics. "
                 "\n\tmVendorID: %x."
                 "\n\tmDeviceID: %x"
                 "\n\tYourCustomDataHere: %x\n",
                 apStatics->mVendorID,
                 apStatics->mDeviceID,
                 apStatics->mYourCustomDataHere);
    }
    else
    {
        kkprintf("GreenDriverDiagnosticsDump_Statics: Null apStatics pointer was passed in.\n");
    }
}

/*****************************************************************************
 *  Green_CreateInfo.c
 *
 *  Copyright (C) 3001, G.Jones
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *  $Revision: 1.0 $
 *  $Author: George Jones $
 *************************************************************************** */
#include <unistd.h>
#include <stdio.h>
#include "Green_info.h"

int main()
{
    long YOUR_VENDOR        = 1;
    long YOUR_DEVICE_ID     = 2;

    GreenDriverInfo  driverInfo =
    {
        YOUR_VENDOR,
        YOUR_DEVICE_ID
    };

    write(1, &driverInfo, sizeof(driverInfo));
    return 0;
}
/*****************************************************************************
 *  Green_info.h
 *
 *  Copyright (C) 3001, G.Jones
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *  $Revision: 1.0 $
 *  $Author: George Jones $
 *************************************************************************** */
#ifndef XXX__GREEN_H
#define XXX__GREEN_H

#ifdef __cplusplus
extern "C"
{
#endif //  __cplusplus

/** This info structure is required for a LynxOS driver.  The contents may be anything,
    but a non-empty structure must exist.  Here, the contents are used as a
    way to pass in initialization parameters to the driver.  These will be used
    during driver and device (these two terms have specific meanings in the
    LynxOS Device Writers Manual) installation.
*/

typedef struct GreenDriverInfo
{
    long    mVendorID;
    long    mDeviceID;
    // ... and feel free to add or change as you like
} GreenDriverInfo;

/** The statics structure is passed to the entry points of your device driver.
    This makes it easy to avoid the use of global variables; easier, in fact,
    than with Linux, for example. With LynxOS, you can put everything in the
    user-defined statics structure.
*/
typedef struct tagGreenDriverStatics
{
     long    mVendorID;
     long    mDeviceID;
     long    mYourCustomDataHere;
     // ... and feel free to add or change as you like
} GreenDriverStatics;

#ifdef __cplusplus
}
#endif //  __cplusplus

#endif // XXX__GREEN_H

sysbrk
sysfree
memset
memcpy
kkprintf
strcpy
recoset
noreco
byte_swap
__outl
__inl
rbounds
wbounds
slevel
ast2
_mail
#!/bin/bash
#############################################################################
#  BuildGreen.bash
#
#  Copyright (C) 3001, G.Jones
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License (LGPL) along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#  $Revision: 1.0 $
#  $Author: George Jones $
#############################################################################

#
# File Contents: This is a bash script to build real device drivers for Linux.
# Please note that there are some commands in this script that require bash,
# not just sh.
#
# Usage:
#
#   BuildDeviceDrivers.sh  [-tidy] [-verbose]
#
#      -tidy removes the object files from the driver directory,
#      so as to make it easier to type the insmod command (for example).
#
#      -verbose shows more details as to what compile and link commands
#      are being issued.
#
# To add an additional, new driver, simply follow these easy steps:
#
#     1. Add the name of the new driver to the PROGRAMS variable.
#     2. Create a new variable, whose name is aaa_FILES, where "aaa" refers to
#        the new name that you added in step 1.
#     3. Add source files to the variable you created in step 2.
#     4. Add any common source files to the COMMON_FILES variable.
#
###############################################################################


PROGRAMS="Green"

# Files for each driver, and files common to more than one driver. Please note
# that full or relative paths may be used, as long as the base file names are
# unique.

Green_FILES="Green.c"
COMMON_FILES=

LYNXOS_KERNEL_SYMBOLS_IMPORT_FILENAME=Green_imports.txt
source CommonBuildRoutines.bash
#!/bin/bash
#############################################################################
#  CommonBuildRoutines.bash
#
#  Copyright (C) 3001, G.Jones
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License (LGPL) along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#  $Revision: 1.0 $
#  $Author: George Jones $
#############################################################################

# Usage: Source this file from within your specific build script.
#
#      -tidy removes the object files from the driver directory,
#      so as to make it easier to type the insmod command (for example).
#
#      -verbose shows more details as to what compile and link commands
#      are being issued.
#
###############################################################################

echo "Performing a clean build of the following drivers: ${PROGRAMS}"

    CC=gcc
    LINK="ld -r"
    KERNELDIR="/usr/src/linux-2.4"
    INCLUDES="-I ${KERNELDIR}/include -I . "
    
    CFLAGS="-D __KERNEL__  -D MODULE -O2 -Wall -Wno-unknown-pragmas -Wno-unused"
    
    CC=gcc
    LINK="ld -bM:SRE -bimport:${LYNXOS_KERNEL_SYMBOLS_IMPORT_FILENAME}"
    INCLUDES=""
    INCLUDES="${INCLUDES} -I/usr/lynx/3.1.0/ppc/sys/include/kernel"
    INCLUDES="${INCLUDES} -I/usr/lynx/3.1.0/ppc/sys/include/family/ppc"
    INCLUDES="${INCLUDES} -I/usr/lynx/3.1.0/ppc/sys/lynx.os"
    
    CFLAGS="-D${TARGET} -O2 -Wall -Wno-unknown-pragmas -Wno-unused -D__NO_INCLUDE_WARN__ -D__LYNXOS"
else
    exit -1       
fi
    

# Search input parameters for position-independent switches:
VERBOSE="false"
TIDY="false"

for ARGS in $*
do
    if [ ${ARGS} = "-tidy" ] ;  then TIDY="true";    fi
done

function compile_files
{
    local sourceFile
    for sourceFile in $*
    do
        echo "Compiling ${sourceFile} ..."
        MakeObjectFileFromSourceFile ${sourceFile}
        
        if [ ${VERBOSE} = "true" ]; then
            echo "${CC} -c ${CFLAGS} ${INCLUDES} ${sourceFile} -o ${OBJ_FILE}"
        fi
        
        ${CC} -c ${CFLAGS} ${INCLUDES} ${sourceFile} -o ${OBJ_FILE}
    done
}

function MakeObjectFileFromSourceFile
{
    local sourceFile=$@
    # Strip off any reference to another directory (such as ../otherDir/)
    # This has the effect of requiring unique source file names, even
    # though they may reside in different directories.
    sourceFile=${sourceFile##*/}
    objFile=${sourceFile%.*}.o
    OBJ_FILE="${TARGET}/${objFile}"
}

function MakeObjectFileListFromSourceFileList
{
    # OBJ_FILE_LIST is not local; function result is placed in this variable.
    OBJ_FILE_LIST=""
    for sourceFile in $*
    do
        MakeObjectFileFromSourceFile ${sourceFile}
        OBJ_FILE_LIST="${OBJ_FILE_LIST} ${OBJ_FILE}"
    done
}

function MakeSourceFileListFromProgramName
{
    # SOURCE_FILE_LIST is not local; function result is placed in this variable.
    SOURCE_FILE_LIST=""
    local programName=$1
    local temp="${programName}_FILES"
    eval SOURCE_FILE_LIST=$(echo "\${${temp}}")
}

function link_files
{
    local programName=$1
    local outputFile=${TARGET}/${programName}.drv
    echo "Linking ${outputFile}..."
    MakeSourceFileListFromProgramName ${programName}
    
    MakeObjectFileListFromSourceFileList ${SOURCE_FILE_LIST} ${COMMON_FILES}
    
    if [ ${VERBOSE} = "true" ]; then
        echo "${LINK} ${OBJ_FILE_LIST} -o ${outputFile}"
    fi
    ${LINK} ${OBJ_FILE_LIST} -o ${outputFile}
}

# Compile files that are unique to each program:
for programName in ${PROGRAMS}
do
    MakeSourceFileListFromProgramName ${programName}
    compile_files ${SOURCE_FILE_LIST}
done

# Compile files that shared among two or more programs:
compile_files ${COMMON_FILES}

# Link each program:
for name in ${PROGRAMS}
do
    link_files ${name}
done

if [ ${TIDY} = "true" ]; then
    echo "Removing intermediate files, because you specified -tidy..."
    rm ${TARGET}/*.o
fi        
/*****************************************************************************
 *  StandardCodeSketchCommands.h
 *
 *  Copyright (C) 3001, G.Jones
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License (LGPL) along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *  $Revision: 1.0 $
 *  $Author: George Jones $
 *************************************************************************** */
#ifndef JFH_STANDARD_CODE_SKETCH_COMMANDS_H
#define JFH_STANDARD_CODE_SKETCH_COMMANDS_H

#define STANDARD_COMMAND_BUFFER_SIZE_CODE_SKETCH  512

#ifdef __cplusplus
extern "C" {
#endif

typedef struct StandardCodeSketchCommands
{
     long    mCommand;
     long    mDataIn;
     long    mDataOut;
     char    mBufferIn [ STANDARD_COMMAND_BUFFER_SIZE_CODE_SKETCH ];
     char    mBufferOut[ STANDARD_COMMAND_BUFFER_SIZE_CODE_SKETCH ];
} StandardCodeSketchCommands;

#define CODE_SKETCH_OVERALL_COMMAND_TO_IOCTL         1000
#define CODE_SKETCH_COMMAND_DUMP                     1001
#define CODE_SKETCH_COMMAND_SEEK_FORWARD             1002
#define CODE_SKETCH_COMMAND_SEEK_BACK                1003

#ifdef __cplusplus
 }
#endif

#endif /* JFH_STANDARD_CODE_SKETCH_COMMANDS_H */
#############################################################################
#  makefile
#
#  Copyright (C) 3001, G.Jones
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License (LGPL) along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#  $Revision: 1.0 $
#  $Author: George Jones $
#############################################################################

all: tidy

debug: verbose

setup: 
	if [ ! -x BuildGreen.bash ]; then chmod u+x BuildGreen.bash; fi
	if [ ! -d ${TARGET} ]; then mkdir ${TARGET};fi

verbose: setup
	./BuildGreen.bash  -verbose

tidy: setup
	./BuildGreen.bash  -tidy

lynx_info: setup ${TARGET}/Green_CreateInfo
	${TARGET}/Green_CreateInfo > ${TARGET}/Green_Info.bin
	
${TARGET}/Green_CreateInfo: Green_CreateInfo.c
	gcc $< -o $@

Building TARGET_OS/Blue.o ...
Building TARGET_OS/Blue_UnitTest.o ...
Linking TARGET_OS/Blue_UnitTest ...
Building for the TARGET_OS platform...
Building TARGET_OS/Red.o ...
Building TARGET_OS/Red_UnitTest.o ...
Linking TARGET_OS/Red_UnitTest ...
Building for the TARGET_OS platform...
Building TARGET_OS/Yellow.o ...
Building TARGET_OS/Yellow_UnitTest.o ...
Linking TARGET_OS/Yellow_UnitTest ...
Building for the TARGET_OS platform...
Building TARGET_OS/Orange.o ...
Building TARGET_OS/Orange_UnitTest.o ...
Linking TARGET_OS/Orange_UnitTest ...
Building for the TARGET_OS platform...
Building TARGET_OS/Fruits.o ...
Building TARGET_OS/Fruits_UnitTest.o ...
Linking TARGET_OS/Fruits_UnitTest ...
Building for the TARGET_OS platform...
Building TARGET_OS/Purple.o ...
Building TARGET_OS/Purple_UnitTest.o ...
Linking TARGET_OS/Purple_UnitTest ...
Building for the TARGET_OS platform...
Building TARGET_OS/Black.o ...
Building TARGET_OS/Black_UnitTest.o ...
Linking TARGET_OS/Black_UnitTest ...
Building for the TARGET_OS platform...
Building TARGET_OS/Grey_UnitTest.o ...
Linking TARGET_OS/Grey_UnitTest ...
Building for the TARGET_OS platform...
