#include "allocator.h"
#include <stdlib.h>
#include <stdio.h>
#include "containerFactory"
#include <vector>
#include <fstream.h>

typedef vector<int,SharedAllocator<int> > VECTOR;
int main(int argc, char* argv[])
{
	int i=0;
	Pool pool(sizeof(void*));
	cout<<"Before First Vector"<<endl;
	pool.print(cout);

	containerFactory cont;
	
	VECTOR* v = cont.getContainer("vector1",(VECTOR*)NULL);
	if (!v) {
		v = cont.createContainer("vector1",(VECTOR*)NULL);
		for (i=0;i<4;i++)
		{
			v->push_back(i);
		}

	}

	for (i=0;i<4;i++) {
		cout<<"v["<<i<<"]="<<(*v)[i]<<endl;
	}

	//cont.removeContainer("vector1",(VECTOR*)NULL);

	cout<<"After Free "<<endl;
	pool.print(cout);
}
