/********************************************************************
 *
 * Code accompanying "Embedded Angle" column in CUJ
 * Copyright (c) 2002 Miro Samek 
 *******************************************************************/
#ifndef fsm_h
#define fsm_h

typedef short Signal;
typedef struct Event Event;
typedef struct Fsm Fsm;
typedef void (*State)(Fsm *, Event const *);

struct Event {
   Signal sig;
};

struct Fsm {
  State state__;
};

#define FsmCtor_(me_, init_) ((me_)->state__ = (State)(init_))
#define FsmInit(me_, e_)     (*(me_)->state__)((me_), (e_)) 
#define FsmDispatch(me_, e_) (*(me_)->state__)((me_), (e_))
#define FsmTran_(me_, targ_) ((me_)->state__ = (State)(targ_))

#endif // fsm_h
